'use strict';

function load_l3(sheet, prefix, cb)
{
	let req = new XMLHttpRequest();
	req.onload = function(e) {
		let response = JSON.parse(req.responseText);
		let l3s = [];
		let i;
		for (i = 0; i < response.values.length; ++i) {
			if (response.values[i][0] === 'Number' ||
			    response.values[i][0] === 'Fake #') {
				++i;
				break;
			}
		}

		for ( ; response.values[i] !== undefined && response.values[i].length >= 3; ++i) {
			let number = response.values[i][0];
			let display_number = response.values[i][1];
			if (number === '') {
				number = display_number;
			}
			let text = response.values[i][2];
			if (display_number !== undefined && display_number !== '') {
				text = "&nbsp;" + display_number + "&nbsp;&nbsp;" + text;
			}
			text = text.replace(/\n/, '<br />');
			let subtext = response.values[i][3];
			if (subtext === undefined || subtext === '') {
				subtext = 'Norwegian Ultimate Championships 2018';
			}

			l3s[prefix + number] = {
				"raw_text": response.values[i][2],
				"text": text,
				"subtext": subtext
			};
			let image = response.values[i][4];
			if (image !== undefined && image.match(/^file:/) !== null) {
				l3s[prefix + number].image = image.match(/^file:(.*)/)[0];
			}
		}
		cb(l3s, sheet);
	};
	req.open('GET', 'https://sheets.googleapis.com/v4/spreadsheets/1VyLIS2GeohLlIRFs6c8kk6g0ZnBFXXiYNh_JROC-iZM/values/\'' + sheet + '\'!A1:J50?key=AIzaSyAuP9yQn8g0bSay6r_RpGtpFeIbwprH1TU');
	req.send();
};

let current_quick_l3s = [];

function quicklowerthird()
{
	let code = current_quick_l3s[state['code']];
	if (code === undefined) {
		return;
	}
	document.getElementById('lowerthird-headline-content').innerHTML = code.text;
	document.getElementById('lowerthird-subheading-content').innerHTML = code.subtext;
	let img = document.getElementById('lowerthird-img');
	if (code.image !== undefined) {
		img.src = code.image;
		img.style.display = 'inline';
	} else {
		img.style.display = 'none';
	}
	showlowerthird();

	if (state['code'].match(/^C/) === null) {
		setTimeout(function() { hidelowerthird(); }, 4000);
	} else {
		setTimeout(function() { hidelowerthird(); }, 6000);
	}
}

function loadquickl3s(sheets)
{
	let newl3s = {};
	let num_left = 1;

	for (let prop in sheets) {
		if (sheets.hasOwnProperty(prop)) {
			++num_left;
		}
	}

	let cb = function(response, group_name) {
		for (let p in response) {
			if (response.hasOwnProperty(p)) {
				newl3s[p] = response[p];
			}
		}
		if (--num_left == 0) {
			current_quick_l3s = newl3s;
		}
	};

	for (let prop in sheets) {
		if (sheets.hasOwnProperty(prop)) {
			load_l3(sheets[prop], prop, cb);
		}
	}
	load_l3('Calls', 'C', cb);
}

// Start by loading calls only
loadquickl3s({});
